/*
 * LCDdisplay.c
 *
 *  Created on: 09/nov/2012
 *      Author: Marco
 */

#include "Watch.h"
#include "LCDdisplay_local.h"
#include "LCDdisplay.h"
#include "ee.h"

void Encode2Digit(unsigned char num, unsigned char digit[])
{
	num=num%100;
	digit[0]=num%10+'0';
	digit[1]=(num/10)%10+'0';
	return;
}

void DisplayD(unsigned char d)
{
	unsigned char buf[2];
	Encode2Digit(d, buf);
	EE_lcd_putc(buf[1]);
	EE_lcd_putc(buf[0]);
}

void DisplayHM(TimeStructType *ts)
{
	DisplayD(ts->hours);
	EE_lcd_putc(':');
	DisplayD(ts->minutes);
}

void DisplayNULL(unsigned char cnt)
{
	unsigned char i;
	for (i=0; i<cnt;i++)
		EE_lcd_putc(' ');
}

void LCDDisplayTime(WatchType *mywatch)
{
	TimeStructType *ts;

	EE_lcd_goto(0,0);
	ts = &(mywatch->time);
	DisplayHM(ts);
	EE_lcd_putc(':');
	DisplayD(ts->seconds);
	DisplayNULL((unsigned char)8);
}

void LCDDisplayAlarm(WatchType *mywatch)
{
	TimeStructType *ts;

	EE_lcd_goto(0,0);
	ts = &(mywatch->alarm);
	DisplayHM(ts);
	DisplayNULL((unsigned char)11);
}

void LCDDisplayChrono(WatchType *mywatch)
{
	TimeStructType *ts;

	EE_lcd_goto(0,0);
	ts = &(mywatch->chrono);
	DisplayHM(ts);
	EE_lcd_putc(':');
	DisplayD(ts->seconds);
	EE_lcd_putc('.');
	EE_lcd_putc((unsigned char)(ts->tenths%10+'0'));
	DisplayNULL((unsigned char)6);
}

void LCDMode(DisplayModesType mode)
{
	EE_lcd_goto(0,1);
	switch (mode) {
	case DMODETIME:
		EE_lcd_puts("Time            ");
		break;
	case DMODETIMESET:
		EE_lcd_puts("Time set        ");
		break;
	case DMODEALARM:
		EE_lcd_puts("Alarm           ");
		break;
	case DMODEALARMSET:
		EE_lcd_puts("Alarm set       ");
		break;
	case DMODECHRONO:
		EE_lcd_puts("Chrono          ");
		break;
	}
	// EE_lcd_putc((millivolt/1000)+'0');
}

void InitLCD(void)
{
	EE_lcd_init();
	EE_lcd_clear();
	EE_lcd_home();
//	EE_lcd_goto( 10, 1 );
}
