/*
 * SWatchFSM.c
 *
 *  Created on: 11/nov/2012
 *      Author: Marco
 */

#include "SWatchFSM.h"
#include "Watch.h"
#include "LCDdisplay.h"

FSMWatch myFSM;

Signal DecodeEvents(unsigned char events)
{
	if (events >= 0x08) return MODE;
	return NOEVENT;
}

void SWatchFSMDispatch(unsigned char events)
{
	switch(myFSM.curState) {
	case DISPLAYTIME:
		switch(DecodeEvents(events)) {
		case MODE:
			// Actions
			// State transition
			SWatchFSMTran(SETTIME);
			LCDMode(DMODETIMESET);
			break;
		default:
			LCDDisplayTime(&myFSM.watch);
			break;
		}
		break;
	case SETTIME:
		switch(DecodeEvents(events)) {
		case MODE:
			// Actions
			// State transition
			SWatchFSMTran(SETALARM);
			LCDDisplayAlarm(&myFSM.watch);
			LCDMode(DMODEALARM);
			break;
		default:
			LCDDisplayTime(&myFSM.watch);
			break;
		}
		break;
	case SETALARM:
		switch(DecodeEvents(events)) {
		case MODE:
			// Transition Actions
			// Exit Actions
			// State transition
			SWatchFSMTran(CHRONO);
			// Entry Actions
			LCDDisplayChrono(&myFSM.watch);
			LCDMode(DMODECHRONO);
			break;
		default:
			LCDDisplayAlarm(&myFSM.watch);
			break;
			}
		break;
	case CHRONO:
		switch(DecodeEvents(events)) {
		case MODE:
			// Transition Actions
			// Exit Actions
			// State transition
			SWatchFSMTran(DISPLAYTIME);
			// Entry Actions
			LCDDisplayTime(&myFSM.watch);
			LCDMode(DMODETIME);
			break;
		default:
			LCDDisplayChrono(&myFSM.watch);
			break;
			}
		break;
	}
}

WatchType *SWatchFSMGetWatch()
{
	return &(myFSM.watch);
}

void SWatchFSMInit()
{
	myFSM.curState = DISPLAYTIME;
	InitWatch(&myFSM.watch);
	LCDMode(DMODETIME);
}

void SWatchFSMTran(State nextstate)
{
	myFSM.curState = nextstate;
}

