/*
 * SWatchFSM2.h
 *
 *  Created on: 11/nov/2012
 *      Author: Marco
 */

#ifndef SWATCHFSM2_H_
#define SWATCHFSM2_H_

#include "Watch.h"

typedef enum Signal_ {
	MODE, SUBMODE, PLUS, MINUS, NOEVENT, NUM_SIGNALS
} Signal;

#define CHSTART PLUS
#define CHSTOP  MINUS
#define CHRESET MINUS
#define CHLAP  SUBMODE

typedef enum State_ {
	DISPLAYTIME, SETTIMEHRS, SETTIMEMINS, SETALARMHRS, SETALARMMINS, CHRONOSTOP, CHRONORUN, CHRONOLAP, NUM_STATES
} State;

typedef struct FSMWatch_ {
	WatchType watch;
	State     curState;
} FSMWatch;

void SWatchFSMDispatch(unsigned char events);
void SWatchFSMInit();
void SWatchFSMTran(State nextstate);
WatchType *SWatchFSMGetWatch();



#endif /* SWATCHFSM2_H_ */
