/*
 * Watch.c
 *
 *  Created on: 11/nov/2012
 *      Author: Marco
 */

#include "Watch.h"

void InitWatch(WatchType *w)
{
	InitTime(&w->time);
	InitTime(&w->alarm);
	InitTime(&w->chrono);
}

void InitTime(TimeStructType *ts)
{
	ts->tenths = 0;
	ts->seconds = 0;
	ts->minutes = 0;
	ts->hours = 0;
}

void TickTenth(TimeStructType *ts)
{
	ts->tenths = (ts->tenths+1)%10;
	if (0 == ts->tenths)
		ts->seconds = (ts->seconds+1)%60;
	else return;
	if (0 == ts->seconds)
		ts->minutes = (ts->minutes+1)%60;
	else return;
	if (0 == ts->minutes)
		ts->hours = (ts->hours+1)%24;
	else return;
}

void ChangeTime(TimeStructType *ts, char hdiff, char mdiff)
{
	ts->minutes = (ts->minutes+mdiff)%60;
	ts->hours = (ts->hours+hdiff)%60;
}
